import 'package:flutter/material.dart';
import 'package:progamification/src/controllers/leader_board.dart';
import 'package:get/get.dart';
import 'package:progamification/src/services/sas_token.service.dart';

class Progress extends StatefulWidget {
  const Progress({super.key});

  @override
  State<Progress> createState() => _ProgressState();
}

class _ProgressState extends State<Progress> {
  LeaderBoardController leaderBoardController =
      Get.find<LeaderBoardController>();

  SasTokenService sasTokenService = Get.find<SasTokenService>();
  String sasToken = "";

  @override
  initState() {
    super.initState();
    sasTokenService.getSasToken().then((value) {
      setState(() {
        sasToken = value.toString();
      });
    });
  }

  @override
  Widget build(BuildContext context) {
    return Container(
        margin: EdgeInsets.only(top: 15.0),
        decoration: const BoxDecoration(
            color: Color.fromARGB(255, 244, 244, 244),
            border: Border(
              bottom: BorderSide(
                color: Color.fromARGB(255, 228, 228, 228),
                width: 1.0,
              ),
            )),
        padding: const EdgeInsets.only(
            left: 20.0, right: 20.0, top: 25.0, bottom: 35.0),
        child: Column(
          children: [
            Padding(
                padding: const EdgeInsets.only(bottom: 5.0),
                child: Row(
                  mainAxisAlignment: MainAxisAlignment.spaceBetween,
                  children: [
                    const Text(
                      "Progress",
                      style: TextStyle(
                          fontSize: 19.0,
                          fontWeight: FontWeight.bold,
                          fontFamily: 'PlusJakartaSans-SemiBold'),
                    ),
                    Row(children: [
                      Image.asset(
                        "assets/icons/bolt.png",
                        package: "progamification",
                        width: 55,
                        height: 55,
                      ),
                      Text(
                          leaderBoardController.userRewards['nextReward']
                                  ['points'] ??
                              '0',
                          style: TextStyle(
                              fontSize: 18.0,
                              fontFamily: 'PlusJakartaSans-SemiBold',
                              fontWeight: FontWeight.w600))
                    ]),
                  ],
                )),
            Container(
                height: 20,
                decoration: BoxDecoration(
                  borderRadius: BorderRadius.circular(10.0),
                  border: Border.all(color: Colors.blue.shade200),
                ),
                child: ClipRRect(
                    borderRadius: BorderRadius.circular(10.0),
                    child: LinearProgressIndicator(
                      backgroundColor: Colors.grey.shade200,
                      color: Colors.blue.shade200,
                      value: int.parse(
                              leaderBoardController.userRewards["progress"]) /
                          100,
                      minHeight: 20,
                    )))
          ],
        ));
  }
}
