import 'dart:convert';

import 'package:dio/dio.dart';
import 'package:progamification/src/constants/service_urls.dart';
import 'package:progamification/src/utilities/http_client.dart';
import 'package:shared_preferences/shared_preferences.dart';

class ProGamificationService {
  Future<dynamic> addPointsToUser(
      Map<String, dynamic> triggerGameAction) async {
    var httpClient = getHttpClient();
    SharedPreferences preferences = await SharedPreferences.getInstance();
    var uid = preferences.getString('userId');
    var appId = preferences.getString('applicationId');
    final response = await httpClient.post(
      ServiceUrls.updateGameAction,
      data: json.encode(triggerGameAction),
      options: Options(
        headers: {
          "userId": uid,
          "appId": appId,
        },
      ),
    );
    if (response.statusCode == 200) {
      return response.data['data'];
    } else {
      return null;
    }
  }
}
