import 'package:dio/dio.dart';
import 'package:progamification/src/interceptors/auth_interceptor.dart';
import 'package:progamification/src/interceptors/error_log_interceptor.dart';
import 'package:progamification/src/environments/env.dart';
import 'package:dio_smart_retry/dio_smart_retry.dart';

Dio getHttpClient() {
  final dio = Dio(BaseOptions(baseUrl: baseUrl))..interceptors.add(Logging());
  dio.interceptors.add(AuthInterceptor());
  dio.interceptors.add(RetryInterceptor(
    dio: dio,
    logPrint: print,
    retries: 3,
    retryDelays: const [
      Duration(seconds: 1), // wait 1 sec before first retry
      Duration(seconds: 2), // wait 2 sec before second retry
      Duration(seconds: 3), // wait 3 sec before third retry
    ],
  ));
  return dio;
}
